/*yasep/cookies.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 20110808 by whygee@f-cpu.org
version mar. nov. 22 23:03:02 CET 2011
depends on core-js/base66s.js

this file manages the persistent user interface parameters.
a "cache" is maintained, numbers are encoded
in base66s. LANG.LANG is updated if a cookie already exists.

in the future : windows are stored as .name-xpos-ypos-xsize-ysize
cookies_cache[0]="-" to skip the introduction page, empty otherwise.
*/

init_obj.push(cookies={
  cache:[],
  first_run:true, // No cookie found so it must be a first run

  // found on the 'web :
  get: function(name) {
    var start = document.cookie.indexOf(name + "="),
      len = start + name.length + 1;
    if ((!start) && (name != document.cookie.substring(0, name.length)))
      return null;
    if (start == -1)
      return null;
    var end = document.cookie.indexOf(";", len);
    if (end == -1)
      end = document.cookie.length;
    return unescape(document.cookie.substring(len, end));
  },

  set:function( name, val, expires, path, domain, secure ) {
    var today = new Date();
    today.setTime( today.getTime() );
    if (expires)
      expires = expires * 86400000; // * 1000 * 60 * 60 * 24;
    var expires_date = new Date( today.getTime() + (expires) );
    document.cookie = name+"="+escape(val) +
      ((expires) ? ";expires="+expires_date.toGMTString() : "" )+
      ((path)    ? ";path=" + path : "" ) +
      ((domain)  ? ";domain=" + domain : "" ) +
      ((secure)  ? ";secure" : "" );
  },

///////////////////////////////////////////////////////////////
// build the megacookie
  save:function(){
    cookies.cache[0]=""+encode_number_base66(LANG.LANG+1);
//    if (FF.target_loopback)
//      cookies.cache[1]=""+FF.target_loopback.replace(/[.]/g,"%2E");
//    else
      cookies.cache[1]="";
    cookies.set("a",cookies.cache.join("."),15); // expiry after 15 days
      // (so you don't get the "first steps" window too often)
  },

///////////////////////////////////////////////////////////////
// manage the YGWM megacookie :
  init_obj: function(){
    var c=cookies.get("a");
    if (!c)
      return;
    cookies.first_run=false;
    cookies.cache=c.split(".");
    if (cookies.cache[0]) {
//      // Trap : "" means 0 in base66 but it also means absent... so I shift/increment the value.
//      // "" will mean nothing yet, "1" means 0=english...
      LANG.LANG=decode_number_base66(cookies.cache[0]+"")-1;  // make sure it's a string
//    if (cookies.cache[1] && (cookies.cache[1]!=""))
//      FF.target_loopback=cookies.cache[1].replace(/[%]2E/g,".");
    }
  }
});
