/* yasep/lang.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 20110909 by whygee@f-cpu.org
20110912 : objectified
20111122 : body_start() can change the default language
20120513 : moved the pictures as divs in logos/logos.css

Some definitions and general utilities for managing the languages.
LANG is also read/written by yasep/cookies.js
*/

// detect the browser's language : 20120829
browsLang=(navigator.browserLanguage||navigator.language).substr(0,2);
/*
  if(navigator.browserLanguage)
    k = navigator.browserLanguage ;
  else
    k = navigator.language ;
  k=k.substr(0,2); // strip the extensions like en-GB or en-US
already seen in the wild : en en-GB en-US es-ES fr
*/

init_obj.push(LANG={
  LANGS:["en", "fr"], // "es"],
  LANGUAGES:["English", "Français"], // "Español"],
  LANG:0, // changed when reading the cookies or by body_start.js (where language detection is performed)
  // LANG could become any large integer number, as it gets encoded/decoded in base66.
  supported:false,

// inline images to save some HTTP requests
  FLAGS:[], // initialised by init_obj

  change_innerHTML: [], // beware of memory leaks !
  change_title: [],

  change_lang: function(i){
    i=+i; // in the case where the argument is a string

    var j,k;
    if ((i<0)||(i>=LANG.LANGS.length))
      i=0;

    LANG.LANG=i;
    l=LANG.LANGS[i];
    cookies.save();

    for (j in LANG.change_innerHTML){
      k=LANG.change_innerHTML[j];
      if(typeof k[1][i] == "string")
        k[0].innerHTML=k[1][i];
      else
        if(typeof k[1][0] == "string")
          k[0].innerHTML=k[1][0];
    }
  },

  // To be called AFTER menu.create() AND init_cookies() !
  init_obj: function() {
    // Create the language picker menu
    var i,l=menu.list["LNG"];

    for (i in LANG.LANGS)  // /!\ i is a string !
      menu.subMenuItem(l,
        [ LANG.FLAGS[i]='<div class="flag_'+LANG.LANGS[i]+'"></div>' ], // Initialises the array
        function(i){
          return function(){
            LANG.change_lang(i) // looks weird but it is a function that
          } // creates another function then calls it for getting a function with closure...
        }(i) 
      ).title=LANG.LANGUAGES[i]; // got it ? :-P

    LANG.change_innerHTML.push([l.firstChild, LANG.FLAGS]);
    l.title="Switch language";
    // set to the current language logo 
    LANG.change_lang(LANG.LANG);
  }
});

// 20120830 : IDEA!!!! :-)
function LS() {
  return arguments[LANG.LANG] || arguments[0]
}
function Alrt(){
  alert (arguments[LANG.LANG] || arguments[0])
}
window.onerror=function(msg, url, l){
 Alrt('Internal error\nmessage: '+msg+'\nURL: '+url+'\nLine Number: '+l
   +'\nYou are hereby kindly advised to\nreport this message and its circumstances\n* on the online chat ("Web" tab) or\n* by email to whygee@f-cpu.org\nThanks !',
      'Erreur interne\nmessage: '+msg+'\nURL: '+url+'\nLine Number: '+l
   +'\nVous êtes cordialement invité à\nreporter ce message et ses circonstances\n* sur le "chat" (dans le menu "Web") ou\n* par email à whygee@f-cpu.org\nMerci !'
 );
 return true
}
